# Class JavaCompiler

java.lang.Object
org.apache.jasper.compiler.Compiler
org.apache.jasper.compiler.JavaCompiler

public class JavaCompiler extends Compiler
Main JSP compiler class. This class uses the Java Compiler API for compiling.

- ## Field Summary

  ### Fields inherited from class Compiler

  `ctxt, errDispatcher, jsw, options, pageInfo, pageNodes, tfp`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `JavaCompiler()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected void`
  `generateClass(Map<String, SmapStratum> smaps)`
  Servlet compilation.

  ### Methods inherited from class Compiler

  `compile, compile, compile, generateJava, getCompilationContext, getErrorDispatcher, getPageInfo, getSmap, init, isOutDated, isOutDated, removeGeneratedClassFiles, removeGeneratedFiles`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### JavaCompiler

    public JavaCompiler()

- ## Method Details

  - ### generateClass

    protected void generateClass(Map<String, SmapStratum> smaps) throws JasperException, IOException
    Description copied from class: `Compiler`
    Servlet compilation. This compiles the generated sources into Servlets.
    Specified by:
      `generateClass` in class `Compiler`
    Parameters:
      `smaps` - The source maps for the class(es) generated from the source file
    Throws:
      `JasperException` - Compilation error
      `IOException`